/* (c) Joerg Schulenburg Jun 2000

 this is part of spin-package

 it is for division of matrix multiplication 
 in parallelizable block matrix multiplication
 
    b = H * a    (a,b vectors, H matrix)
    
    b[i] = sum_j H[i,j] * a[j]
    
 blocks can be multiplicated step by step on one system or
 they can be multiplicated on different processors/systems
 
 but you have to pay additional network/harddisk traffic
 
 if b_num is one you have only one block (similar to old version)


 */
#include "block.h"

unsigned long b_ofs[B_NUM];	/* start index 0..n1-1 of block */
unsigned long b_len[B_NUM];	/* block len */
unsigned long b_hnz[B_NUM];	/* block entries */
unsigned long b_snz[B_NUM];	/* stored block entries */
unsigned long b_sn1[B_NUM];	/* stored block lines */
int b_bits=0;			/* b_len[0..n-2]=1l<<b_bits */
unsigned long b_mask=0;			/* ~((~0)<<b_bits) */
struct thxy b_hbuf[B_NUM][HBLen]; /* buffer for faster access */ 
struct thxy *b_hbp[B_NUM];        /* puffer-pointer */      
unsigned long b_hbl[B_NUM];       /* num valid data in buffer bufh */  
      

/* calculate blocknumber (0..B_NUM-1) from idx (0..n1-1) */
/* used for store blocks of hamilton (future) and converted relikts */
int b_getnum(unsigned long idx){	/* do it fast as possible! */
  int i,j;
  for(j=0,i=1<<(B_NL2-1);i;i>>=1){
    if( idx >= b_ofs[j|i] ) j|=i;
  }
  return j;
}

/* initialization, n1 is whole matrix size */
int b_ini(unsigned long n1,int vvv){
  int i;
  unsigned long l,l1,l2;
  /* lenght of on block round up to 2^n
     for easier generation of block-no. and offset from 0..n1 index
   */
  l=n1/B_NUM;
#ifdef CONFIG_noB_MASK      /* faster, but subject of change */
  b_mask=0; b_bits=0; l++;
#else
  for(b_mask=~0l,b_bits=0;(l>>b_bits)!=0;b_mask<<=1,b_bits++);
  l=1l<<b_bits; b_mask=~b_mask;
#endif
  for(l1=n1,i=0;i<B_NUM;i++){
    if( l1>=l ) l2=l; else l2=l1;
    if( i==0  ) b_ofs[i]=0; else b_ofs[i]=b_ofs[i-1]+b_len[i-1];
    b_len[i]=l2;
    b_hnz[i]=0;   
    b_snz[i]=0;   
    b_sn1[i]=0;
    b_hbp[i]=&b_hbuf[i][0]; /* evl. b_hbuf dyn. allocieren */
    b_hbl[i]=0;
    l1-=l2;
  }
  if(vvv){
    printf(" b_bits=%d b_mask=%08lx (b_no=i1>>b_bits)\n",b_bits,b_mask);
    if (vvv>1)
    for(i=0;i<B_NUM;i++)
     printf(" block %2d from %8lu len %8lu\n",i,b_ofs[i],b_len[i]);
  }
  return 0;
}
