/*
     this is the config.h file v0.1
     main idea is that you will find here all
     macro-definitions for configuring the spin-program
     it is not necessary to edit other files any more (Feb2000)
 */
#ifndef _CONFIG_H
#define _CONFIG_H
#define CONFIG_noB_MASK 1		/* faster, but subject of change */
#ifndef NN
#define NN       16			/* Number of sites/spins */
#define Nw	 (4*NN)			/* Number of bounds */
#define Title     "JJ-Model"    	/* simple string */
#endif
#define CM(JJ,tJ,tU) JJ	  /* Heisenberg-,  t-J- or  Hubbard-model */
#define NEW  4		/* number of eigenvalues to calculate */
#define SBase 1		/* SBase/noSBase = with/without symmetry */ 

#undef CONFIG_ANSATZ    /* define/undef CONFIG_ANSATZ for using this! */

#define Zahl      1	/* 1 should be the default value! */
/* 0=float,1=double,2=long dbl,4=complex-flt (c++),5=complex-dbl (c++) Apr99 */

/* --- ABEL(NOABEL) Nutzung abelscher(nichtabelscher) Symmetriegruppe --- */
#define CONFIG_NOABEL 1		/* CONFIG_ABEL or CONFIG_NOABEL */

/* --- S1SYM - besondere Behandlung der Spin-1 ((n>1)/2) Symmetrie --- */
#define CONFIG_S1SYM  1		/* CONFIG_S1SYM or CONFIG_NOS1SYM */
/*
 *  CONFIG_S1SYM useful for spin-1 systems with a lot of symmetries
 *             - does reduce the time needed for scanning for symmetries
 *             - this option should vanish in later versions (js Okt.98)
 */
/*
 * #define HFIELD if you want to have a magnetic field on each site
 * #undef  HFIELD if you do not need a magnetic field, its a bit faster
 */
#undef HFIELD
/*
 * #define CONFIG_TBC if you want to have a TBC (twisted boundary conditions)
 * #undef  CONFIG_TBC if you do not need TBC, its faster
 */
#undef CONFIG_TBC

#define MaxSym   410      /* ggf. aendern, braucht int*(3*NN+5) Memory */

#endif
