#ifndef _VECTOR_H
#define _VECTOR_H
#include "array_m.h"

/* name for vector files (groundstate, startvec, excitation, temp) */
#define FileGS   "d%d.vec"
#define FileSV   "s%d.vec"
#define FileEX   "d%de.vec"
#define FileTM   "t%d.vec"
#define FileEV   "tmp/ev%d.vec"

#ifdef NoSnprintf
/* some systems do not know more secure sprintf-version */
#define snprintf(a,b,c,d) sprintf(a,c,d)
#endif

void   mltply_av(double r, tvec *v0);  /* v0*=r */
void   clrvec(tvec *v);
double normvec(tvec *v);

/* if blk==-1 save all blocks, idx>=0 index for name="d%d.vec" */
int savevec( tvec *v,const char *nam,int idx,int blk);
int loadvec( tvec *v,const char *nam,int idx,int blk);
int loadvec2(tvec *v,const char *nam, int idx);  /* lade vec von textfile */
   
void randvec(tvec *v,int ini);
cplx sprod(tvec *a, tvec *b); /* Skalarprodukt REIHENFOLGE!!!! */
int  iortho(tvec *v0, tvec *v1); /* 0=ok,1=parallel */

#endif
